﻿#include "define.h"
#include "sort.h"
#include "resolve.h"

// IN
	uniform int	   bucketFragments;

#if multisample
	layout(binding = 0, r32ui) readonly uniform uimage2DMSArray image_next;
#else
	layout(binding = 0, r32ui) readonly uniform uimage2DArray	image_next;
#endif 
	layout(binding = 1, rg32f) readonly uniform  imageBuffer	image_peel;
	layout(binding = 2, r32ui) readonly uniform uimageBuffer	image_pointers;

#if multisample
	uint getPixelCurrentPageID	(const ivec3 coords)				{return imageLoad(image_next	 , coords, gl_SampleID).x;}
#else
	uint getPixelCurrentPageID	(const ivec3 coords)				{return imageLoad(image_next	 , coords).x;}
#endif
	vec4 sharedPoolGetValue		(const uint index)					{return imageLoad (image_peel	 , int(index))  ;}
	uint sharedPoolGetLink		(const uint index)					{return imageLoad (image_pointers, int(index)).x;}

// OUT
	layout(location = 0, index = 0) out vec4 out_frag_color;

	void main(void)
	{
		ivec2 coords = ivec2(gl_FragCoord.xy);

		int		counter, total_counter=0;
		uint	page_id, glob_pID;

		for (int b=0; b<BUCKET_SIZE; b++)
		{
			page_id = getPixelCurrentPageID(ivec3(coords,b));
			if(page_id > 0U)
			{
				glob_pID = uint(bucketFragments*b);
				page_id += glob_pID;

				counter  = 0;
				while(page_id > glob_pID)
				{
					fragments[counter++] = sharedPoolGetValue(page_id).rg;
					page_id = sharedPoolGetLink(page_id);
				}
							
				if(counter > 0)
				{
					int c = total_counter;
					total_counter += counter;
					if(layer+1 > total_counter)
						continue;

					sort(counter);
					out_frag_color = unpackUnorm4x8(uint(fragments[layer-c].x)).abgr;
					return;
				}
			}
		}
		discard;
	}