﻿#include "define.h"

#if multisample
	layout(binding = 0, r32ui) readonly uniform uimage2DMS	    image_counter;
	layout(binding = 1, rg32f) readonly uniform  image2DMSArray image_peel;	
#else
	layout(binding = 0, r32ui) readonly uniform uimage2DRect	image_counter;
	layout(binding = 1, rg32f) readonly uniform  image2DArray	image_peel;
#endif

#if multisample
	float getPixelFragDepth	 (const ivec3 coords) {return imageLoad(image_peel   , coords, gl_SampleID).g;}
	uint  getPixelFragCounter(const ivec2 coords) {return imageLoad(image_counter, coords, gl_SampleID).x;}
#else
	float getPixelFragDepth	 (const ivec3 coords) {return imageLoad(image_peel   , coords).g;}
	uint  getPixelFragCounter(const ivec2 coords) {return imageLoad(image_counter, coords).x;}
#endif

	layout(location = 0, index = 0) out vec4 out_frag_depth;

	void main(void)
	{
		ivec2 coords = ivec2(gl_FragCoord.xy);

		uint counter = getPixelFragCounter(coords);
		if(counter == 0U)
			discard;

		out_frag_depth.r = getPixelFragDepth (ivec3(coords, count-1U));
	}