﻿#include "define.h"
#include "sort.h"
#include "resolve.h"

#if multisample
	layout(binding = 0, r32ui) readonly uniform uimage2DMS	    image_counter;
	layout(binding = 1, rg32f) readonly uniform  image2DMSArray image_peel;
#else
	layout(binding = 0, r32ui) readonly uniform uimage2DRect	image_counter;
	layout(binding = 1, rg32f) readonly uniform  image2DArray	image_peel;
#endif 

#if multisample
	uint getPixelFragCounter (const ivec2 coords) {return imageLoad (image_counter, coords, gl_SampleID).x;}
	vec4 getPixelFragValue	 (const ivec3 coords) {return imageLoad (image_peel   , coords, gl_SampleID);}
#else
	uint getPixelFragCounter (const ivec2 coords) {return imageLoad (image_counter, coords).x;}
	vec4 getPixelFragValue	 (const ivec3 coords) {return imageLoad (image_peel   , coords);}
#endif

	layout(location = 0, index = 0) out  vec4 out_frag_color;

	void main(void)
	{
		ivec2 coords = ivec2(gl_FragCoord.xy);

		int counter = int(getPixelFragCounter(coords));
		if(counter > 0)
		{
			for(int i=0; i<counter; i++)
				fragments[i] = getPixelFragValue(ivec3(coords, i)).rg;
			out_frag_color = resolve(counter);
		}
		else
			discard;
	}