﻿#include "define.h"

#if multisample
	uniform sampler2DMS tex_peel_0;
	uniform sampler2DMS tex_peel_1;
	uniform sampler2DMS tex_peel_2;
	uniform sampler2DMS tex_peel_3;
	uniform sampler2DMS tex_peel_4;
	uniform sampler2DMS tex_peel_5;
	uniform sampler2DMS tex_peel_6;
	uniform sampler2DMS tex_peel_7;
#else
	uniform sampler2DRect tex_peel_0;
	uniform sampler2DRect tex_peel_1;
	uniform sampler2DRect tex_peel_2;
	uniform sampler2DRect tex_peel_3;
	uniform sampler2DRect tex_peel_4;
	uniform sampler2DRect tex_peel_5;
	uniform sampler2DRect tex_peel_6;
	uniform sampler2DRect tex_peel_7;
#endif

layout(location = 0, index = 0) out vec4 out_frag_depth;

void main(void)
{
	vec4 k[KB_SIZE];
#if multisample
	k[0] = texelFetch(tex_peel_0, ivec2(gl_FragCoord.xy), gl_SampleID);
	k[1] = texelFetch(tex_peel_1, ivec2(gl_FragCoord.xy), gl_SampleID);
	k[2] = texelFetch(tex_peel_2, ivec2(gl_FragCoord.xy), gl_SampleID);
	k[3] = texelFetch(tex_peel_3, ivec2(gl_FragCoord.xy), gl_SampleID);
	k[4] = texelFetch(tex_peel_4, ivec2(gl_FragCoord.xy), gl_SampleID);
	k[5] = texelFetch(tex_peel_5, ivec2(gl_FragCoord.xy), gl_SampleID);
	k[6] = texelFetch(tex_peel_6, ivec2(gl_FragCoord.xy), gl_SampleID);
	k[7] = texelFetch(tex_peel_7, ivec2(gl_FragCoord.xy), gl_SampleID);
#else
	k[0] = texture(tex_peel_0, gl_FragCoord.xy);
	k[1] = texture(tex_peel_1, gl_FragCoord.xy);
	k[2] = texture(tex_peel_2, gl_FragCoord.xy);
	k[3] = texture(tex_peel_3, gl_FragCoord.xy);
	k[4] = texture(tex_peel_4, gl_FragCoord.xy);
	k[5] = texture(tex_peel_5, gl_FragCoord.xy);
	k[6] = texture(tex_peel_6, gl_FragCoord.xy);
	k[7] = texture(tex_peel_7, gl_FragCoord.xy); 
#endif
	
	float maxZ = 0.0f;
	for (int i = 0; i < KB_SIZE; i++)
	{
		if(k[i].g == 1.0f)
		{
			maxZ = 1.0f;
			break;
		}
		else if(k[i].g > maxZ)
			maxZ = k[i].g;
#if packing
		if(k[i].a == 1.0f)
		{
			maxZ = 1.0f;
			break;
		}
		else if(k[i].a > maxZ)
			maxZ = k[i].a;
#endif
	}
	out_frag_depth.r = maxZ;
}