﻿#include "define.h"
#include "s-buffer.h"

	uniform uint  total_fragments;
	uniform uint *final_address[COUNTERS];

// INCLUDE
	vec4 computePixelColor();
// IN
#if multisample
	layout(binding = 1, r32ui) coherent  uniform uimage2DMS   image_next;
#else
	layout(binding = 1, r32ui) coherent  uniform uimage2DRect image_next;
#endif 
	layout(binding = 4, rg32f) writeonly uniform imageBuffer  image_peel;

#if multisample
	uint addPixelNextAddress  (const ivec2 coords, const uint val)	{ return imageAtomicAdd	(image_next, coords, gl_SampleID, val);}
#else
	uint addPixelNextAddress  (const ivec2 coords, const uint val)	{ return imageAtomicAdd	(image_next, coords, val);}
#endif 
	void sharedPoolSetValue	  (const uint index  , const vec4 val)	{		 imageStore		(image_peel, int(index), val);}

void main(void)
{
	ivec2 coords  = ivec2(gl_FragCoord.xy);

	vec4  value   = vec4(packUnorm4x8(computePixelColor().abgr), gl_FragCoord.z, 0.0f, 0.0f);
	uint  page_id = addPixelNextAddress(coords, 1U);
	int   hash_id = coords.y % COUNTERS;
	uint  sum     = (*final_address[hash_id]) + page_id;

#if inverse
	uint  index = hash_id < COUNTERS2 ? sum : total_fragments - sum;
#else
	uint  index = sum;
#endif

	sharedPoolSetValue (index, value);
}