﻿#include "define.h"

// Include
vec4 computePixelColor();
// IN
#if multipass
	uniform sampler2DRect tex_depth;
#endif
// OUT
layout(location = 0, index = 0) out vec4 out_frag_color;

void main(void)
{
#if multipass
	if(gl_FragCoord.z <= texture(tex_depth, gl_FragCoord.xy).r)
		discard;
#endif
	vec4 c = computePixelColor().abgr;
	out_frag_color = vec4(packUnorm4x8(c), gl_FragCoord.z, 0.0f, 0.0f);
}