﻿#define GL_FRAGMENT_PRECISION_HIGH 1

#define multisample 0 // for Multisample Rendering : all except {SRAB}
#define packing		0 // for attribute packing : {F2B-KB, DUAL-KB, KB, MultiKB}

#define early_Z		1 // early z-culling
#define a_buffer	1 // extension for FAB, Linked Lists and S-Buffer Implementations : {F2B-FAB, F2B-LL, DUAL-FAB, DUAL-LL, FAB, Linked Lists, S-Buffer}

#if a_buffer || packing || early_Z
#version 420 core
#elif multisample
#version 400 core
#else
#version 330 core
#endif
#if a_buffer
#extension GL_NV_gpu_shader5 : enable
#extension GL_NV_shader_buffer_load : enable
#endif

#define multipass			0 // transform method to its multipass version : {KB, MultiKB, SRAB, BUN, FAB}
#define draw_buffers_blend	1 // blending function per MRT {F2B-3P, F2B-2P, DUAL-2P}
#define sorted_by_id		0 // sort captured fragments by primitive id : {F2B-K, F2B-FAB, F2B-LL, DUAL-KB, DUAL-FAB, DUAL-LL}
#define BUCKET_SIZE			5 // depth range is divided to BUCKET_SIZE subintervals : { BUCKET_LL }

#define STENCIL_SAMPLES		8	// { SRAB }
#define KB_SIZE				8	// { F2B-KB, DUAL-KB, KB, MultiKB, SRAB }
#define FAB_SIZE			50	// { F2B-FAB, DUAL-FAB, FAB }
#define BUCKET_SIZE			5	// { BUCKET_LL }

#define depth_max	1.0f
#define float_max   3.40282e+038f
#define float_min  -3.40282e+038f
#define uint_max    4294967295