﻿#define SORT_SHELL			1	
#define SORT_MERGE			0	
#define SORT_INSERT			0	
#define SORT_SELECT			0	
#define SORT_BUBBLE			0	

vec2 fragments[FAB_SIZE];

#if SORT_BUBBLE
	void sort(const int num)
	{
		vec4 c0,c1;

		for (int i = (num - 2); i >= 0; --i)
		{
			for (int j = 0; j <= i; ++j)
			{
				c0 = fragments[j  ];
				c1 = fragments[j+1];

				if (c0.g > c1.g)
				{
					fragments[j  ] = c1;
					fragments[j+1] = c0;
				}
			}
		}
	}
#endif

#if SORT_SHELL
	void sort(const int num)
{
	int inc = num / 2;
	while (inc > 0)
	{
		for (int i = inc; i < num; ++i)
		{
			vec2 tmp = fragments[i];

			int j = i;
			while (j >= inc && fragments[j - inc].g > tmp.g)
			{
				fragments[j] = fragments[j - inc];
				j -= inc;
			}
			fragments[j] = tmp;
		}
		inc = int(inc / 2.2f + 0.5f);
	}
}
#endif

#if SORT_MERGE
	vec2 leftArray[FREEPIPE_SIZE/2];

	void merge(int steps, int a, int b, int c)
{
	int i;
	for (i = 0; i < steps; ++i)
		leftArray[i] = fragments[a+i];

	i = 0;
	int j = 0;
	for (int k = a; k < c; ++k)
	{
		if (b+j >= c || (i < steps && leftArray[i].g < fragments[b+j].g))
			fragments[k] = leftArray[i++];
		else
			fragments[k] = fragments[b+j++];
	}
}
	void sort(const int num)
{
	int n	  = num;
	int steps = 1;

	while (steps <= n)
	{
		int i = 0;
		while (i < n - steps)
		{
			merge(steps, i, i + steps, min(i + steps + steps, n));
			i += 2 * steps;
		}
		steps *= 2;
	}
}
#endif

#if SORT_INSERT
	void sort(const int num)
{
	for (int j = 1; j < num; ++j)
	{
		vec2 key = fragments[j];
		int i = j - 1;

		while (i >= 0 && fragments[i].g > key.g)
		{
			fragments[i+1] = fragments[i];
			--i;
		}
		fragments[i+1] = key;
	}
}
#endif

#if SORT_SELECT
	void sort(const int num)
{
	vec2 t;
	for (int j = 0; j < num-1; ++j)
	{
		int swap = j;
		for (int i = j+1; i < num; ++i)
		{
			if (fragments[swap].g > fragments[i].g)
				swap = i;
		}

		t				= fragments[swap];
		fragments[swap] = fragments[j];
		fragments[j]	= t;
	}
}
#endif

#endif